// $Id$
//
// Copyright (C) 2006 

// Definition of non-inline non-template functions

#include "Connection.hh"
//#include "Connection.ih"

// Custom includes

//#include "Connection.mpp"
#define prefix_
///////////////////////////////cc.p////////////////////////////////////////

prefix_ g0dil::mediaserv::Connection::Connection(int fileFd, unsigned bytesPerSecond,
                                                 ClientHandle client, unsigned bufferMSecs)
    : fileFd_(fileFd), bytesPerSecond_(bytesPerSecond), client_(client),
      bufferMSecs_(bufferMSecs), bytesWritten_(0), start_(satcom::lib::now()),
      bufferSize_(0), terminate_(false)
{
    registerCallback();
    fillBuffer();
}

prefix_ void g0dil::mediaserv::Connection::fillBuffer()
{
    bufferSize_ = ::read(fileFd_,buffer_,packetSize);
    if (bufferSize_ < packetSize)
	terminate_ = true;
    // TODO: Check error;
}

prefix_ void g0dil::mediaserv::Connection::callback(ClientHandle client,
                                                    satcom::lib::Scheduler::EventId)
{
    unsigned target (targetBytes());
    if (target - bytesWritten_ >= bufferSize_) {
	if (client_.write(buffer_,bufferSize_) < bufferSize_)
	    // TODO: Destroy client handle ..
	    ;
	bytesWritten_ += bufferSize_;
	if (terminate_) {
	    unregisterCallback();
	    // TODO: Destroy client handle
	} else
	    fillBuffer();
    } else {
	unregisterCallback();
	registerTimeout(((bufferSize_-(target-bytesWritten_))*1000)/bytesPerSecond_);
    }
}

prefix_ void g0dil::mediaserv::Connection::timeout()
{
    registerCallback();
}

///////////////////////////////cc.e////////////////////////////////////////
#undef prefix_
//#include "Connection.mpp"


// Local Variables:
// mode: c++
// End:
