// $Id$
//
// Copyright (C) 2006 

#ifndef HH_Connection_
#define HH_Connection_ 1

// Custom includes
#include <boost/utility.hpp>
#include "Utils/MicroTime.hh"
#include "Scheduler/Scheduler.hh"
#include "Socket/ClientSocketHandle.hh"
#include "Socket/CommunicationPolicy.hh"
#include "Socket/FramingPolicy.hh"
#include "Socket/BufferingPolicy.hh"
#include "Socket/ReadWritePolicy.hh"

//#include "Connection.mpp"
///////////////////////////////hh.p////////////////////////////////////////

namespace g0dil {
namespace mediaserv {

    class Connection : boost::noncopyable
    {
    public:
        ///////////////////////////////////////////////////////////////////////////
        // Types

	typedef satcom::lib::ClientSocketHandle<
	    satcom::lib::MakeSocketPolicy<satcom::lib::ConnectedCommunicationPolicy,
				    	  satcom::lib::StreamFramingPolicy,
				    	  satcom::lib::WriteablePolicy,
				    	  satcom::lib::SocketBufferingPolicy>::policy> ClientHandle;

	static const unsigned packetSize = 1400;

        ///////////////////////////////////////////////////////////////////////////
        ///\name Structors and default members
        ///@{

        Connection(int fileFd, unsigned bytesPerSecond, ClientHandle client,
		   unsigned bufferMSecs);

        ///@}

    protected:

    private:
	void registerCallback();
	void unregisterCallback();
	void registerTimeout(unsigned timeout);
	unsigned targetBytes();
	void fillBuffer();
	
	void callback(ClientHandle client, satcom::lib::Scheduler::EventId);
	void timeout();
	

	int fileFd_;
	unsigned bytesPerSecond_;
	ClientHandle client_;
	unsigned bufferMSecs_;

	unsigned bytesWritten_;
	satcom::lib::MicroTime start_;
	unsigned bufferSize_;
	char buffer_[packetSize];
	bool terminate_;
    };

}}

///////////////////////////////hh.e////////////////////////////////////////
#include "Connection.cci"
//#include "Connection.ct"
//#include "Connection.cti"
//#include "Connection.mpp"
#endif


// Local Variables:
// mode: c++
// End:
